osgManipulator::TabBoxDragger Class Reference

`#include <TabBoxDragger>`

Inheritance diagram for osgManipulator::TabBoxDragger:

## Public Member Functions

| TabBoxDragger ()
| META_OSGMANIPULATOR_Object (osgManipulator, TabBoxDragger) void setupDefaultGeometry()
void | setPlaneColor (const osg::Vec4 &color)
Public Member Functions inherited from osgManipulator::CompositeDragger
| META_Node (osgManipulator, CompositeDragger)
virtual const CompositeDragger * | getComposite () const
virtual CompositeDragger * | getComposite ()
virtual void | setParentDragger (Dragger *parent)
virtual bool | handle (const PointerInfo &pi, const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &aa)
virtual bool | addDragger (Dragger *dragger)
template<class T>
bool | addDragger (const osg::ref_ptr< T > &dc)
virtual bool | removeDragger (Dragger *dragger)
template<class T>
bool | removeDragger (const osg::ref_ptr< T > &dc)
unsigned int | getNumDraggers () const
Dragger * | getDragger (unsigned int i)
const Dragger * | getDragger (unsigned int i) const
bool | containsDragger (const Dragger *dragger) const
template<class T>
bool | containsDragger (const osg::ref_ptr< T > &dc) const
DraggerList::iterator | findDragger (const Dragger *dragger)
virtual void | setIntersectionMask (osg::Node::NodeMask intersectionMask)
Public Member Functions inherited from osgManipulator::Dragger
| META_Node (osgManipulator, Dragger)
Dragger * | getParentDragger ()
const Dragger * | getParentDragger () const
void | setHandleEvents (bool flag)
bool | getHandleEvents () const
void | setActivationModKeyMask (unsigned int mask)
unsigned int | getActivationModKeyMask () const
void | setActivationMouseButtonMask (unsigned int mask)
unsigned int | getActivationMouseButtonMask () const
void | setActivationKeyEvent (int key)
int | getActivationKeyEvent () const
virtual void | traverse (osg::NodeVisitor &nv)
virtual bool | handle (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &aa)
void | addConstraint (Constraint *constraint)
template<class T>
void | addConstraint (const osg::ref_ptr< T > &c)
void | removeConstraint (Constraint *constraint)
template<class T>
void | removeConstraint (const osg::ref_ptr< T > &c)
Constraints & | getConstraints ()
const Constraints & | getConstraints () const
void | addDraggerCallback (DraggerCallback *dc)
template<class T>
void | addDraggerCallback (const osg::ref_ptr< T > &dc)
void | removeDraggerCallback (DraggerCallback *dc)
template<class T>
void | removeDraggerCallback (const osg::ref_ptr< T > &dc)
DraggerCallbacks & | getDraggerCallbacks ()
const DraggerCallbacks & | getDraggerCallbacks () const
void | addTransformUpdating (MatrixTransform *transform, int handleCommandMask=DraggerTransformCallback::HANDLE_ALL)
void | removeTransformUpdating (MatrixTransform *transform)
virtual void | setupDefaultGeometry ()
virtual bool | receive (const MotionCommand &command)
virtual void | dispatch (MotionCommand &command)
void | setDraggerActive (bool active)
bool | getDraggerActive () const
osg::Node::NodeMask | getIntersectionMask () const
bool | inverted () const
void | applyAppropriateFrontFace (osg::StateSet *ss) const
Public Member Functions inherited from osg::MatrixTransform
| MatrixTransform ()
| MatrixTransform (const MatrixTransform &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| MatrixTransform (const Matrix &matix)
| META_Node (osg, MatrixTransform)
virtual MatrixTransform * | asMatrixTransform ()
virtual const MatrixTransform * | asMatrixTransform () const
void | setMatrix (const Matrix &mat)
const Matrix & | getMatrix () const
void | preMult (const Matrix &mat)
void | postMult (const Matrix &mat)
const Matrix & | getInverseMatrix () const
virtual bool | computeLocalToWorldMatrix (Matrix &matrix, NodeVisitor *) const
virtual bool | computeWorldToLocalMatrix (Matrix &matrix, NodeVisitor *) const
Public Member Functions inherited from osg::Transform
| Transform ()
| Transform (const Transform &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Transform)
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual PositionAttitudeTransform * | asPositionAttitudeTransform ()
virtual const PositionAttitudeTransform * | asPositionAttitudeTransform () const
virtual AutoTransform * | asAutoTransform ()
virtual const AutoTransform * | asAutoTransform () const
void | setReferenceFrame (ReferenceFrame rf)
ReferenceFrame | getReferenceFrame () const
virtual BoundingSphere | computeBound () const
Public Member Functions inherited from osg::Group
| Group ()
| Group (const Group &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Group)
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual bool | addChild (Node *child)
template<class T>
bool | addChild (const ref_ptr< T > &child)
virtual bool | insertChild (unsigned int index, Node *child)
template<class T>
bool | insertChild (unsigned int index, const ref_ptr< T > &child)
virtual bool | removeChild (Node *child)
template<class T>
bool | removeChild (const ref_ptr< T > &child)
bool | removeChild (unsigned int pos, unsigned int numChildrenToRemove=1)
virtual bool | removeChildren (unsigned int pos, unsigned int numChildrenToRemove)
virtual bool | replaceChild (Node *origChild, Node *newChild)
template<class T, class R>
bool | replaceChild (const ref_ptr< T > &origChild, const ref_ptr< R > &newChild)
virtual unsigned int | getNumChildren () const
virtual bool | setChild (unsigned int i, Node *node)
Node * | getChild (unsigned int i)
const Node * | getChild (unsigned int i) const
bool | containsNode (const Node *node) const
template<class T>
bool | containsNode (const ref_ptr< T > &node) const
unsigned int | getChildIndex (const Node *node) const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~TabBoxDragger ()
Protected Member Functions inherited from osgManipulator::CompositeDragger
| CompositeDragger ()
| CompositeDragger (const CompositeDragger &rhs, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual | ~CompositeDragger ()
Protected Member Functions inherited from osgManipulator::Dragger
| Dragger ()
| Dragger (const Dragger &rhs, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual | ~Dragger ()
Protected Member Functions inherited from osg::MatrixTransform
virtual | ~MatrixTransform ()
Protected Member Functions inherited from osg::Transform
virtual | ~Transform ()
Protected Member Functions inherited from osg::Group
virtual | ~Group ()
virtual void | childRemoved (unsigned int, unsigned int)
virtual void | childInserted (unsigned int)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

std::vector< osg::ref_ptr< TabPlaneDragger > > | _planeDraggers
Protected Attributes inherited from osgManipulator::CompositeDragger
DraggerList | _draggerList
Protected Attributes inherited from osgManipulator::Dragger
bool | _handleEvents
bool | _draggerActive
unsigned int | _activationModKeyMask
unsigned int | _activationMouseButtonMask
int | _activationKeyEvent
bool | _activationPermittedByModKeyMask
bool | _activationPermittedByMouseButtonMask
bool | _activationPermittedByKeyEvent
osgManipulator::PointerInfo | _pointer
Dragger * | _parentDragger
osg::ref_ptr< DraggerCallback > | _selfUpdater
Constraints | _constraints
DraggerCallbacks | _draggerCallbacks
osg::Node::NodeMask | _intersectionMask
Protected Attributes inherited from osg::MatrixTransform
Matrix | _matrix
Matrix | _inverse
bool | _inverseDirty
Protected Attributes inherited from osg::Transform
ReferenceFrame | _referenceFrame
Protected Attributes inherited from osg::Group
NodeList | _children
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osgManipulator::CompositeDragger
typedef std::vector< osg::ref_ptr< Dragger > > | DraggerList
Public Types inherited from osgManipulator::Dragger
typedef std::vector< osg::ref_ptr< Constraint > > | Constraints
typedef std::vector< osg::ref_ptr< DraggerCallback > > | DraggerCallbacks
Public Types inherited from osg::Transform
enum | ReferenceFrame { RELATIVE_RF , ABSOLUTE_RF , ABSOLUTE_RF_INHERIT_VIEWPOINT }
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

TabBoxDragger consists of 6 TabPlaneDraggers to form a box dragger that performs translation and scaling.

## Constructor & Destructor Documentation

## TabBoxDragger()

osgManipulator::TabBoxDragger::TabBoxDragger | ( |  | ) |

Referenced by META_OSGMANIPULATOR_Object().

## ~TabBoxDragger()

virtual osgManipulator::TabBoxDragger::~TabBoxDragger | ( |  | ) |

protected virtual

## Member Function Documentation

## META_OSGMANIPULATOR_Object()

osgManipulator::TabBoxDragger::META_OSGMANIPULATOR_Object | ( | osgManipulator | ,
|  | TabBoxDragger | )

Setup default geometry for dragger.

References osgManipulator::Dragger::setupDefaultGeometry(), and TabBoxDragger().

## setPlaneColor()

void osgManipulator::TabBoxDragger::setPlaneColor | ( | const osg::Vec4 & | color | ) |

## Member Data Documentation

## _planeDraggers

std::vector< osg::ref_ptr< TabPlaneDragger > > osgManipulator::TabBoxDragger::_planeDraggers

protected

The documentation for this class was generated from the following file:

- TabBoxDragger